#include <stdlib.h>
#include "nrutil.h"
double ** inverse(double **a,int N)
{
	double **y,*col;
	int i,d,j,*indx;
	y=(double**)malloc(sizeof(double*)*(N+1));
	for (i=0;i<=N;i++)
	{
		y[i]=(double*)calloc(sizeof(double),(N+1));
	}
	indx=(int*)calloc(sizeof(int),(N+1));
	col=(double*)calloc(sizeof(double),(N+1));

	ludcmp(a,N,indx,&d);
	for(j=1;j<=N;j++)
	{
		for(i=1;i<=N;i++)
			col[i]=0.0;
		col[j]=1.0;
		lubksb(a,N,indx,col);
		for(i=1;i<=N;i++)
			y[i][j]=col[i];
	}
	return y;
}
